<?php

/*
 * HostBill bitpay gateway module
 * @see http://larsasoft.com
 *
 * 2013 HostBill -  Complete Client Management, Support and Billing Software
 * http://www.larsasoft.com
 */

class bitpay extends PaymentModule {

    protected $modname = 'درگاه پرداخت بیت پی';

    protected $description = 'این ماژول توسط سایت لارسا سافت نوشته شده است';

    protected $supportedCurrencies = array();


    protected $configuration = array(
        'api' => array(
            'value' => '',
            'type' => 'input',
            'description' => 'لطفا کلید api خود را وارد کنید'
        ),
		'success_message' => array(
            'value' => 'پرداخت با موفقیت انجام شد',
            'type' => 'input',
            'description' => 'پیام موفقیت'
        ),
    );

    public function drawForm() {
        function send($url,$api,$amount,$redirect){
				$ch = curl_init();
				curl_setopt($ch,CURLOPT_URL,$url);
				curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&amount=$amount&redirect=$redirect");
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
				curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
				$res = curl_exec($ch);
				curl_close($ch);
				return $res;
				}
				
				
		$url = 'https://bitpay.ir/payment/gateway-send';
			
			$api = $this->configuration['api']['value'] ;
			$amount = $this->amount;
			$redirect = urlencode($this->callback_url) ;
			$_SESSION['invoiceid']=$this->invoice_id;
			$_SESSION['amount']= $amount;
			
			$result = send($url,$api,$amount,$redirect);
				if($result > 0 && is_numeric($result)){
					$_SESSION['id_get']= $result;
				$go = "https://bitpay.ir/payment/gateway-$result";
				header("Location: $go");
				}
				switch($result){
					case '-1':
					echo 'api ارسالی با نوع api تعریف شده در bitpay .سازگار نیست';
					break;
					case '-2':
					echo ' مقدار amount .داده عددي نمی باشد و یا کمتر از 1000 ریال است';
					break;
					case '-3':
					echo ' مقدار redirect رشته null .است';
					break;
					case '-4':
					echo ' .درگاهی با اطلاعات ارسالی شما یافت نشده و یا در حالت انتظار می باشد';
					break;
				}
    }
	

    function callback() {  
	
			function get($url,$api,$trans_id,$id_get){
				$ch = curl_init();
				curl_setopt($ch,CURLOPT_URL,$url);
				curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
				curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
				$res = curl_exec($ch);
				curl_close($ch);
				return $res;
				}     
				$url = 'https://bitpay.ir/payment/gateway-result-second';
				$api = $this->configuration['api']['value'];
				$trans_id = $_POST['trans_id'];
				$id_get = $_POST['id_get'];
				$result = get($url,$api,$trans_id,$id_get);


        if ( $result == 1 && $_SESSION['id_get']== $id_get) {
            //2. log incoming payment
            $this->logActivity(array(
                'result' => 'Successfull',
                'output' => $_POST
            ));

            //3. add transaction to invoice
            $invoice_id = $_SESSION['invoiceid'];
            $amount = $_SESSION['amount'];
            $fee = 0;
            $transaction_id = get($trans_id);
            
            $this->addTransaction(array(
                'in' => $amount,
                'invoice_id' => $invoice_id,
                'fee' => $fee,
                'transaction_id' => $transaction_id
		      
            ));
			$this->addInfo($this->configuration['success_message']['value']);
            Utilities::redirect('?cmd=clientarea');
       
            
        } else {
             $this->logActivity(array(
                'result' => 'Failed',
                'output' => $_POST
				
            ));
			Utilities::redirect('?cmd=clientarea');
			
			
        }
    }

}
